<?php
require_once 'Zend/Controller/Plugin/Abstract.php';
/**
* Zend_Controller_Plugin preparing Doctrine ORM
*/
class My_Controller_Plugin_Doctrine extends Zend_Controller_Plugin_Abstract
{
    public function dispatchLoopStartup (Zend_Controller_Request_Abstract $request)
    {
    	self::setupDoctrine();
		self::setupSession();
	}

	/**
	 * setupDoctrine
	 * @access public static
	 * @param
	 * @return null
	 */
	public static function setupDoctrine() {
		$config = Zend_Registry::get('config');
		$connection = Doctrine_Manager::connection(sprintf(
											 '%s://%s:%s@%s/%s',
											 strtolower($config->db->adapter),
											 $config->db->username,
											 $config->db->password,
											 $config->db->host,
											 $config->db->dbname
											 )
									 );

		// set connection manager attributies here
		// $manager = Doctrine_Manager::getInstance();
		// $manager->setAttribute(Doctrine::ATTR_VALIDATE, Doctrine::VALIDATE_ALL);
		// $manager->setAttribute(Doctrine::ATTR_EXPORT, Doctrine::EXPORT_ALL);
		// $manager->setAttribute(Doctrine::ATTR_AUTOLOAD_TABLE_CLASSES, true);
		// $manager->setAttribute(Doctrine::ATTR_USE_DQL_CALLBACKS, true);
		// $manager->setAttribute(Doctrine::ATTR_AUTO_ACCESSOR_OVERRIDE, true);
		// $manager->setAttribute(Doctrine::ATTR_QUOTE_IDENTIFIER, true);
		// $manager->setAttribute(Doctrine::ATTR_AUTOLOAD_TABLE_CLASSES, false);

		$configDoctrine = $config->doctrine->toArray();
		foreach ($configDoctrine as $key => $value) {
			$configDoctrine[$key] = $value[0] === '/' ? Bootstrap::$root . $value : Bootstrap::$root . '/' . $value;
		}
		Zend_Registry::set('config_doctrine', $configDoctrine);
	}

	/**
	 * Start session and handle it using Doctrine
	 * @access public static
	 * @return null
	 */
	public static function setupSession() {
		Zend_Session::setSaveHandler(new My_Session_Doctrine());
		Zend_Session::start();
	}
}