<?php
require_once 'Zend/Controller/Plugin/Abstract.php';
/**
 * Zend_Controller_Plugin preparing View
 */
class My_Controller_Plugin_ViewSetup extends Zend_Controller_Plugin_Abstract
{
    public function dispatchLoopStartup (Zend_Controller_Request_Abstract $request)
    {
        $root = Bootstrap::$root;

        $viewRenderer = Zend_Controller_Action_HelperBroker::getStaticHelper('viewRenderer');

        /*$view = new Zend_View();*/
        // now we are using PHPTAL View
        $view = new My_PHPTAL_ZFView();

        $view->addScriptPath($root . '/application/modules/'
                             . $request->getModuleName() . '/views/templates'
                             )
             ->doctype('XHTML1_STRICT');

        $viewRenderer->setView($view)
                     ->setViewSuffix('tpl.html')
                     ->init();

        // setup Zend_Layout
        Zend_Layout::startMvc(array(
                                    'layoutPath' => $root
                                     . '/application/modules/default/views/layouts',
                                     'layout' => 'main' , 'viewSuffix' => 'tpl.html'
                                    )
                              );

        // add this two lines if you wish to use PHPTAL
        $phptal = new PHPTAL;
        $view->setEngine($phptal);

        // phptal options
        $phptal->setPhpCodeDestination($root . '/temp')
               ->setForceReparse(true)
        // pre filter to support traditional Zend_View syntax in templates
               ->setPreFilter(new My_PHPTAL_Filter_ZFSyntax());
    }
}
