<?php

class My_Session_Doctrine implements Zend_Session_SaveHandler_Interface
{
	private $_sessionName;
	private $_session;
	private $_lifetime;

	public function __construct($lifetime = null)
	{
		if(is_null($lifetime))
		{
			$this->_lifetime = (int) ini_get('session.gc_maxlifetime');
		}
		else
		{
			$this->_lifetime = (int) $lifetime;
		}
	}

	public function setLifetime($lifetime)
	{
		$this->_lifetime = $lifetime;
	}

	public function getLifetime()
	{
		return $this->_lifetime;
	}

	public function read($id)
	{
		$this->_session = Doctrine::getTable('Session')->find($id);

		if(empty($this->_session))
		{
			$this->_session = new Session();
			$this->_session->id = $id;
			$this->_session->lifetime = $this->_lifetime;

			return '';
		}
		return $this->_session->data;
	}

	public function write($id, $data)
	{
		$this->_session->data = $data;
		$this->_session->modified = time();
		$this->_session->save();

		return true;
	}

	public function destroy($id)
	{
		if($this->_session->id == $id)
		{
			$this->_session->delete();
			return true;
		}
		return false;
	}

	public function gc($maxlifetime)
	{
		Doctrine_Query::create()->delete('Session s')->where('s.modified < (? - s.lifetime)', time())->execute();
	}

	public function open($save_path, $name)
	{
		$this->_sessionName = $name;
		return true;
	}

	public function close()
	{
		return true;
	}
}